package com.sf.day05.day08.innerclass;

public class OuterClass {
    public void method() {
        final int outerVar = 10; // 或者只是effectively final

        class LocalInnerClass {
            public void display() {
                System.out.println("Outer var: " + outerVar);
            }
        }

        LocalInnerClass inner = new LocalInnerClass();
        inner.display();
    }

    public static void main(String[] args) {
        OuterClass outer = new OuterClass();
        outer.method(); // 调用包含局部内部类的方法
    }
}
