package com.sf.day05.day08.lambda;

import java.util.Random;

public class IRandomableTest {

    public static void main(String[] args) {
        useRandomable(new IRandomable() {
            @Override
            public int getRandom() {
                return (int) (Math.random()*1000);
            }
        });


        useRandomable( () ->  {
            int nextInt = new Random().nextInt();
            return nextInt;
        });

        useRandomable( () ->
             new Random().nextInt()
        );

    }

    public static void useRandomable(IRandomable iRandomable){
        int random = iRandomable.getRandom();
        System.out.println(random);

    }}
