package com.sf.day05.day08.lambda;

public class IShowableTest {

    public static void main(String[] args) {
        //  匿名内部类的方式
        useShowable(new IShowable() {
            @Override
            public void show() {
                System.out.println("~~~~~~~~~");
            }
        });


        //  lambda表达式的方式
       useShowable(() -> System.out.println("~~~~~~~~~"));
    }

    public static void useShowable(IShowable iShowable){
     iShowable.show();
    }
}
