package com.sf.day05.day08.lambda;

import java.util.ArrayList;
import java.util.List;

public class Te {

    public static void main(String[] args) {
        List<Product> productByPrice = findProductByPrice(Data.products);
        System.out.println(productByPrice);
        List<Product> productByName = findProductByName(Data.products);
        System.out.println(productByName);
    }


    //  筛选出所有商品中价格大于1000的商品
    public static List<Product>  findProductByPrice(List<Product> products){
        List<Product> lists = new ArrayList<>();
        for (Product product : products) {
            if(product.getPrice() > 1000){
                lists.add(product);
            }
        }
        return lists;
    }

    //  筛选出所有名称包含手机的商品
    public static List<Product>  findProductByName(List<Product> products){
        List<Product> lists = new ArrayList<>();
        for (Product product : products) {
            if(product.getName().contains("手机")){
                lists.add(product);
            }
        }
        return lists;
    }
}
