package com.sf.day05.day08.lambda;

import java.util.ArrayList;
import java.util.List;

public class Te2 {


    public static void main(String[] args) {
        //   手机名称
        List<Product> list = findProductByCondition(Data.products, product -> product.getName().contains("手机"));
        System.out.println(list);


        //  价格
        List<Product> productByCondition = findProductByCondition(Data.products, new MyPredicate() {
            @Override
            public boolean test(Product product) {
                return product.getPrice() > 1000;
            }
        });
        System.out.println(productByCondition);
    }


    public static List<Product> findProductByCondition(List<Product> lists,MyPredicate myPredicate){
        List<Product> list = new ArrayList<>();
        for (Product product : lists) {
            if(myPredicate.test(product)){
                list.add(product);
            }
        }
        return list;
    }
}
