package com.sf.day09;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Predicate;
import java.util.function.Supplier;

public class te {
    /**
     *  编写 shop 方法输出消费多少元
     */
    public static void shop(int money, Consumer<Integer> consumer){
        consumer.accept(money);
    }

    public static void main(String[] args) {
        shop(500, integer -> System.out.println("消费integer~"));
        getCode(5, () -> (int) Math.random()*10);
        System.out.println(getStringRealLength("helloworld",str -> str.length()));
        List<String> list = Arrays.asList("abc","wolf","wolfcode","wolfcode.cn");
        getString(list,str -> str.length()>5).forEach(System.out::println);
    }


    /**
     * :编写 getCode 方法返回指定位数的随机验证码字符串
     */

    public static String getCode(int number, Supplier<Integer> supplier){
        StringBuilder stringBuilder = new StringBuilder();
        for (int i = 0;i<number;i++){
            stringBuilder.append(supplier.get());
        }
        return stringBuilder.toString();
    }

    /**
     * 编写 getStringRealLength 方法返回字符串真实长度
     */

    public static  int getStringRealLength(String str, Function<String,Integer> function){
        return function.apply(str);
    }

    /**
     * 编写 getString 方法返回长度大于5的字符串的集合
     */
    public static List<String> getString(List<String> list , Predicate<String> predicate){
        List<String> list1 = new ArrayList<>();
        for (String s : list) {
            if(predicate.test(s)){
                list1.add(s);
            }
        }
        return list1;
    }


}
