package com.sf.day04;

import org.junit.Test;

import java.util.Scanner;

public class HomeWork01 {
    /**
     * 案例需求：假设从2000年1月1日开始
     * 三天打鱼，两天晒网，
     * 从键盘输入今天的日期年、月、日，
     * 显示今天是打鱼还是晒网？
     * 检查输入的合法性
     * @param args
     */
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        System.out.println("请输入日期");
        int year;
        while (true){
            System.out.println("请输入年份~");
             year = scanner.nextInt();
             //  判断合法性
            if(year >= 2000){
                break;
            }else {
                System.out.println("输入的年份必须大于等于2000，请重新输入~");
            }
        }

        int month;
        while (true){
            System.out.println("请输入月份~");
            month = scanner.nextInt();
            //判断月份的合法性
            if(month >= 1  &&  month <= 12){
                break;
            }else {
                System.out.println("输入的月份有误，请重新输入~");
            }
        }

        //  判断每个月的天数
        int totalDaysOfMonth;
        if(month == 2){
            // 闰年
            if((year % 4 == 0 &&  year % 100 != 0) || year % 400 == 0 ){
                totalDaysOfMonth = 29;
            }else {
                totalDaysOfMonth = 28;
            }
        }else if (month == 4 || month == 6 || month == 9 ||month == 11 ){
            totalDaysOfMonth = 30;
        }else {
            totalDaysOfMonth = 31;
        }


        // 日
        int day;
        while (true){
            System.out.println("日~");
            day = scanner.nextInt();
            if(day < 0){
                System.out.println("输入有误");
            }else if (day > totalDaysOfMonth){
                System.out.println("您输入的年份是"+year+"年"+month+"月,这个月有"+ totalDaysOfMonth+"天");
            }else {
                break;
            }
        }

        // 计算总天数 【2000  - year - 1】
        int days = 0;
        for (int i = 2000;i<year;i++){
            if((year % 4 == 0 &&  year % 100 != 0) || year % 400 == 0 ){
                days += 366;
            }else {
                days += 365;
            }
        }


        for (int i= 1;i < month;i++){
            if (i == 4 || i == 6 || i == 9 ||i == 11 ){
                days += 30;
            }else if(i ==2){
                if((year % 4 == 0 &&  year % 100 != 0) || year % 400 == 0 ){
                    days += 29;
                }else {
                    days += 28;
                }
            }else {
                days += 31;
            }
        }
        days += day;
        // 判断是打鱼还是筛网
        if(days % 5 == 1 || days % 5 == 2  || days % 5 == 3){
            System.out.println("打鱼~");
        }else {
            System.out.println("晒网~");
        }
    }


    //  打印『X』对称图形
    @Test
    public void t1(){
     for (int i= 1;i<=7;i++){
         for (int j= 1;j<=7;j++){
             if(j == i || j == 8 - i){
                 System.out.print("O");
             }else {
                 System.out.print("*");
             }
         }
         System.out.println();
     }
    }


    //  打印空心菱形
    @Test
    public void t2(){
        for (int i = 1;i<=5;i++){
            for (int j = 4;j>=i;j--){
                System.out.print("  ");
            }

            //  ✳
            for (int k = 1;k<=2*i-1 ;k++){
                if(k == 1 ||  k == 2*i-1){
                    System.out.print("*");
                }else {
                    System.out.print("  ");
                }
            }
            System.out.println();
        }

        for (int m = 1;m <= 4; m++){
            for (int n = 1;n <= m; n++){
                System.out.print("  ");
            }
            //   *
            for (int o = 1;o<=9 -2 * m;o++){
                if(o  == 1 ||  o == 9 -2 * m){
                    System.out.print("*");
                }else {
                    System.out.print("  ");
                }
            }
            System.out.println();
        }
    }
}
