package com.sf.day05.day08;

public class Rectangle implements ShapeInterface{

    private double length;
    private double wide;

    public Rectangle() {
    }

    public Rectangle(double length, double wide) {
        this.length = length;
        this.wide = wide;
    }

    public double getLength() {
        return length;
    }

    public void setLength(double length) {
        this.length = length;
    }

    public double getWide() {
        return wide;
    }

    public void setWide(double wide) {
        this.wide = wide;
    }

    @Override
    public double getArea() {
        return length*wide;
    }

    @Override
    public double getPerimeter() {
        return 2*(length+wide);
    }

    @Override
    public String display() {
        return "Rectangle{" +
                "length=" + length +
                ", wide=" + wide +
                ",Area"+getArea()+",Perimeter"+getPerimeter()+
                '}';
    }

    @Override
    public String toString() {
        return "Rectangle{" +
                "length=" + length +
                ", wide=" + wide +
                '}';
    }
}
