package com.sf.day05.day08.flay;

public class Chicken extends Bird implements Flyable{
    @Override
    public void eat() {
        System.out.println("鸡吃谷子~");
    }

    @Override
    public void fly() {
        System.out.println("鸡上房揭瓦，满院子乱扑腾~");
    }


    /**
     * 各种鸟的测试类
     * @param args
     */
    public static void main(String[] args) {
        Bird[] birds = new  Bird[3];
        birds[0] = new Penguin();
        birds[1] = new Swan();
        birds[2] = new Chicken();
//        System.out.println(Arrays.toString(birds));
        for (Bird bird : birds) {
            bird.eat();
            if(bird instanceof Flyable){
                Flyable flyable = (Flyable) bird;
                flyable.fly();
            }
            if(bird instanceof Swimming){
                Swimming swimming = (Swimming) bird;
                swimming.swim();
            }

        }


    }
}
