package com.sf.day06;

import java.util.Arrays;

public class Student {
    public int number;
    public int state;
    public int score;

    /**
     * 构造器
     * 权限修饰符  类名(){
     *
     * }
     * @return
     *  当前类没有构造器  系统会默认添加午无参构造器
     *  构造器的作用：
     *  1、对象的创建
     *  2、属性的赋值
     */

    public Student(){

    }

    public Student(int number,int score,int state){
        this(number,score);
        this.state = state;

    }

    public Student(int number,int score){
        this.number = number;
//        this.state = state;
        this.score = score;

    }

    public Student(int number){
        this.number = number;
    }
    @Override
    public String toString() {
        return "Student{" +
                "number=" + number +
                ", state=" + state +
                ", score=" + score +
                '}';
    }


    public static void main(String[] args) {
        Student[] students = new Student[5];
        for (int i= 0;i<students.length;i++){
            Student student = new Student();
            student.number = i+1;
            student.state = i+1;
            student.score = (int) (Math.random()*100)+1;
            students[i] = student;
        }
        System.out.println(Arrays.toString(students));
        Student infoByState = getInfoByState(students);
        System.out.println(infoByState);

        System.out.println(Arrays.toString(students));
    }

    /**
     * 获取年纪为3的学生信息
     * @param student
     * @return
     */
    public static  Student getInfoByState(Student[] student){
        for (Student student1 : student) {
            if(student1.state == 3){
                return student1;
            }
        }
        return null;
    }




}
