package com.sf.day06.entend;

public class DepositCard {
    private String id;
    private Double balance;

    public DepositCard() {
    }

    public DepositCard(String id, Double balance) {
        this.id = id;
        this.balance = balance;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Double getBalance() {
        return balance;
    }

    public void setBalance(Double balance) {
        this.balance = balance;
    }

    @Override
    public String toString() {
        return "DepositCard{" +
                "id='" + id + '\'' +
                ", balance=" + balance +
                '}';
    }

    /**
     * 取款
     * @param money
     */
    public void withdraw(double money){
     if(money < 0 ){
         System.out.println("取款金额不能为负数~");
     }else if (money > balance){
         System.out.println("取款金额不能大于余额");
     }else {
         balance -= money;
     }
    }

    /**
     * 存款
     * @param money
     */
    public void save(double money){
        if(money <0){
            System.out.println("存款不能为负数~");
        }else {
            balance += money;
        }
    }

    public String getInfo() {
        return "DepositCard{" +
                "id='" + id + '\'' +
                ", balance=" + balance +
                '}';
    }

}
