package com.sf.day07;

public class Student extends Person{
    private double score = 100;

    public Student() {
        //super(); // 调用父类无参构造方法,默认就存在，可以不写，必须再第一行
        System.out.println("子类无参");
    }

    public Student(double score){
        this.score = score;
    }

    public Student(String name ,int age,double score) {
        super(name ,age);// 调用父类有参构造方法,初始化name和age
        this.score = score;
        System.out.println("子类有参");
    }

    public double getScore() {
        return score;
    }

    public void setScore(double score) {
        this.score = score;
    }

    @Override
    public String toString() {
        return "Student{" +
                "score=" + score +
                '}';
    }

    public static void main(String[] args) {
        // 调用子类有参数构造方法
        Student s2 = new Student("张三",20,99);
        System.out.println(s2.getScore()); // 99
        System.out.println(s2.getName()); // 输出 张三
        System.out.println(s2.getAge()); // 输出 20
        System.out.println(s2);
    }
}
