package com.sf.day07.lx;

public interface BuildCarsInterface {

    //静态常量
      int MAX_SPEED = 220;//km/h

    int MIN_DISTANCE = 50; //m

    //抽象方法
    //参数 汽油
    //返回 速度
     void runCar();
     void breakCar();

    //默认方法
    default void start(){
        System.out.println("开始");
    }
    default void stop(){
        System.out.println("结束");
    }

    //静态方法
    static void show(){
        System.out.println("中国汽车必将走向世界");
    }

    //私有提示
    default void error(){
        System.out.println("超速");
    }
}
